c
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c                PROGRAMME DE CALCUL DE DISTANCE
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
c fevrier 2001
c 
c prend en compte les donnees manquantes
c
c TRAITE LES RESULTATS DE CLAUDE SIMULATIONS (12/98)
c ARCHITECTURE: 2 POP ISSUES D UNE ANCETRE AVEC SORTIES FREQUENCE
c ALLELIQUES X FOIS SUR CHAQUE BRANCHE
c
c PROGRAMME MODIFIER POUR DISTANCE ANTRE POPULATIONS DE LA MEME
c  GENERATION ET CROISEMENT DE TOUTES LES GENERATIONS
c FICHIER JVa_ex_phyl ET DERIVES  (TAPER 1)FICHIER PARAMETRE 'param99'
c FICHIER Fre_rn250_20 ET DERIVES (TAPER 2)FICHIER PARAMETRE 'param99b'
c
c PROGRAMME MODIFIER POUR DONNEES REELLES
c (LECTURE du nombre d indiv par locus apres le nom des populations)
c
c ATTENTION
c DISTANCES CORRIGEES PAR : nombre d indiv par populations et par locus 
c nindiv(ipop,iloc)
c
c FICHIER PARAMETRE 'param99'
c PROGRAMME JUSTE : VERIFIE AVEC GENDIST POUR METHODE 5
c MODIF METHODE 6 REDONNENT RESULTATS METHODE 5




      implicit double precision (a-h,o-z)
      parameter(ngenmax=5,npopmax=80,nlocmax=150,nallmax=50)
      character*10 nompop(npopmax)
      integer nsim0,nall(nlocmax),nloc,npop
      integer necht(npopmax),nlocv(npopmax)
      integer nindiv(npopmax,nlocmax),nindiv2(npopmax,nlocmax)
      integer igardeloc(nlocmax)
c      integer ntall(nlocmax,nallmax)
      double precision freqall0(ngenmax,npopmax
     &,nlocmax,nallmax),het(npopmax,nlocmax),hetglob(npopmax)
      double precision alleffm(npopmax),alleff(npopmax,nlocmax)
      double precision allobsm(npopmax),allobs(npopmax,nlocmax)
      double precision allobsloc(nlocmax)
      double precision distboot(ngenmax,ngenmax,npopmax,npopmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      double precision sd(ngenmax,ngenmax,npopmax,npopmax)
      double precision varboot(ngenmax,ngenmax,npopmax,npopmax)
      character*50 fichdon1,fichboot,fichdon2
      character*50 fichneighbo,fichsolu1,fichlistp,fichlistloc
      character*5 fnomdist
      
      integer npopv(nlocmax),nalldiagn(npopmax,nlocmax)
     & ,nalldiagnm(npopmax)
      double precision freqmoy(nlocmax,nallmax),nlocvm,
     &   freqall(ngenmax,npopmax,nlocmax,nallmax),
     &   d2(ngenmax,ngenmax,npopmax,npopmax),
     &   sd2(ngenmax,ngenmax,npopmax,npopmax),d1t(npopmax)
      double precision monoloc(npopmax),monopop(nlocmax),monom

      common /bloc1/ igardeloc
c 12/12/02      
      common /bloc2/ isortieloc
	isortieloc=0
c 

c  %%%%%%%%%%%%%%%%%%%%%%%
c  % PROGRAMME PRINCIPAL %
c  %%%%%%%%%%%%%%%%%%%%%%%
c      write(*,*)'Ce programme permet de calculer une distance'
c      write(*,*)'gntique au choix parmi plusieurs distances'
c      write(*,*)'Il est applicable aussi bien  des donnes' 
c      write(*,*)'relles qu a des donnes simules.'

C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C     NOM DES FICHIERS ENTREE SORTIE %
C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      write(*,*)'Entrez le nom du fichier de frequences'
      read(*,*)fichdon1
      open(1,file=fichdon1)
      
      write(*,*)'Entrez le nom du fichier des tailles de pop'
      write(*,*)' puis la valeur min de la taille d echt'
      read(*,*)fichdon2,seuil_tail
      open(2,file=fichdon2)
      
      ndonnee=1
      nsim0=ndonnee
      nmicrosat=2


c       %%%%%%%%%%%%%%%%%%%%%%%%%%%
c          CHANGER LES PARAMETRES %
c       %%%%%%%%%%%%%%%%%%%%%%%%%%%

      npar=2



c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c                                         %
c    TRAITEMENT DE VRAIES POPULATIONS     %
c                                         %
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      

      ngen=2
 100  format(20(f5.3))
      write(*,*)'Donnees non boostrappees, taper 0 '
      write(*,*)'sinon taper le nombre de bootstrap '
      read(*,*)nboot
      
       write(*,*) 'nmethode'
      read(*,*)nmethode
      if(nmethode.gt.9) stop 6

      write(*,*)'Fichier avec liste des pop'      
      read(*,*)fichlistp
      open(3,file=fichlistp)
      
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
c DONNEES NON BOOTSTRAPPEES   %
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      IF(nboot.eq.0)then
            write(*,*)'Fichier avec liste des locus'
            read(*,*)fichlistloc
            open(13,file=fichlistloc)
       read(1,*)npopl,nloc
c       write(*,*)npopl,nloc
       if(npopl.gt.npopmax) stop 1
       if(nloc.gt.nlocmax) stop 2
       read(13,*)
       read(13,*)(igardeloc(iloc),iloc=1,nloc)
       read(2,*)
       read(1,*)(nall(iloc),iloc=1,nloc)
       do iloc=1,nloc
          if(nall(iloc).gt.nallmax) stop 4
	  allobsloc(iloc)=0
       enddo
       read(2,*)       
       do igen=2,ngen
       
       ipop=0
       read(3,*,iostat=ieof)ip,nompop(ip)
       write(*,*)'de listepop ',ip,nompop(ip)
       
       do ipopl=1,npopl
        
	if(ip.eq.ipopl.and.ieof.eq.0)then 
	
	   ipop=ipop+1
	
        read(1,*)nompop(ipop),((freqall0(igen,ipop,iloc
     &,iall),iall=1,nall(iloc)),iloc=1,nloc)
c	write(*,*)nompop(ipop)	
	read(2,*)	
	read(2,*)(nindiv(ipop,iloc),iloc=1,nloc)
c        write(*,*)nompop(ipop),(nindiv(ipop,iloc),iloc=1,3)

	
	if(ipopl.ne.npopl)read(3,*,iostat=ieof)ip,nompop(ip)
		
	else
	
        read(1,*)nompop(npopl),((freqall0(igen,npopl,iloc
     &,iall),iall=1,nall(iloc)),iloc=1,nloc)
	read(2,*)	
	read(2,*)(nindiv(npopl,iloc),iloc=1,nloc)	

		   
	endif	
	
       enddo
       enddo

       npop=ipop
       
c le 9/7/1 : si les tailles d'echt sont inf a une val seuil,
c    alors on met les freq a zero pour ne pas considerer
c     cette cb pop x marq
       igen=2
       do ipop=1,npop
          do iloc=1,nloc
	     if(nindiv(ipop,iloc).lt.seuil_tail)then
	        do iall=1,nall(iloc)	        
    	           freqall0(igen,ipop,iloc,iall)=0.		   	     
	        enddo
	     endif
          enddo
       enddo       
       
       
       
       
c calcul des heterozygoties, alleles observes et efficaces
	igen=2
	
	do iloc=1,nloc
	   do iall=1,nall(iloc)
	      freqmoy(iloc,iall)=0.	      
	   enddo
	   monopop(iloc)=0
	   npopv(iloc)=0
	enddo
	
	do iloc=1,nloc
	if(igardeloc(iloc).ne.0)then
	   do iall=1,nall(iloc)
	      do ipop=1,npop
	         freqmoy(iloc,iall)=freqmoy(iloc,iall)+
     &               freqall0(igen,ipop,iloc,iall)
              enddo
	   enddo
	endif
c	write(*,*)iloc,(freqmoy(iloc,iall),iall=1,nall(iloc))
	enddo
	
	nlocvm=0
	hetglobm=0
	alleffmm=0
	allobsmm=0
	nalldiagnmt=0
	d1tm=0
	monom=0
	
	do ipop=1,npop
c        hetglob(ipop)=1.
           hetglob(ipop)=0.
	   alleffm(ipop)=0.
	   allobsm(ipop)=0.
	   nlocv(ipop)=0.
	   nalldiagnm(ipop)=0
	   monoloc(ipop)=0
	   
	   do iloc=1,nloc
	      nalldiagn(ipop,iloc)=0
	      if(igardeloc(iloc).ne.0)then
              som=0.
	      het(ipop,iloc)=0.
	      allobs(ipop,iloc)=0
	          do iall=1,nall(iloc)
	              f=freqall0(igen,ipop,iloc,iall)
	              som=som+f
	              het(ipop,iloc)=het(ipop,iloc)+f*f
	     if(f.ne.0)allobs(ipop,iloc)=allobs(ipop,iloc)+1
	              if(f.ne.0..and.(freqmoy(iloc,iall)-f).eq.0.)
     &                    nalldiagn(ipop,iloc)=nalldiagn(ipop,iloc)+1
	          enddo

                if(het(ipop,iloc).eq.1.)then
		   monoloc(ipop)=monoloc(ipop)+1
		   monopop(iloc)=monopop(iloc)+1
		end if
		 if(som.ne.0.) then
c	    hetglob(ipop)=hetglob(ipop)*het(ipop,iloc)
c on corrige l'homozygotie par l'effectif
                  het(ipop,iloc)=
     &               (het(ipop,iloc)-1./nindiv(ipop,iloc))
     &                /  (1.-1./nindiv(ipop,iloc))
	          hetglob(ipop)=hetglob(ipop)+1.-het(ipop,iloc)	   
	          nlocv(ipop)=nlocv(ipop)+1
		  if(het(ipop,iloc).le.0)write(*,*)ipop,iloc,het(ipop,iloc)
	          alleff(ipop,iloc)=1./het(ipop,iloc)
     	          alleffm(ipop)=alleffm(ipop)+alleff(ipop,iloc)
	          het(ipop,iloc)=1.-het(ipop,iloc)
	          allobsm(ipop)=allobsm(ipop)+allobs(ipop,iloc)	
		  npopv(iloc)=npopv(iloc)+1 
	         else
	          het(ipop,iloc)=9
	          alleff(ipop,iloc)=0.
		  write(*,*)'som=0 ',ipop,iloc
	         endif	  
	         if (som.ne.0..and.som.ne.1.)then
	            write(*,*)nompop(ipop),iloc,som
c	            stop 10
	         endif
	         allobsloc(iloc)=max(allobs(ipop,iloc),allobsloc(iloc))
		 nalldiagnm(ipop)=nalldiagnm(ipop)+nalldiagn(ipop,iloc)		 
	    endif 
    
	   enddo
c	    hetglob(ipop)=(1.-hetglob(ipop))/nlocv(ipop)
	   hetglob(ipop)=hetglob(ipop)/nlocv(ipop)
	   alleffm(ipop)=alleffm(ipop)/nlocv(ipop)
	   allobsm(ipop)=allobsm(ipop)/nlocv(ipop)
	   monoloc(ipop)=monoloc(ipop)/nlocv(ipop)
c	   nalldiagnm(ipop)=nalldiagnm(ipop)/nlocv(ipop)
           nlocvm=nlocvm+nlocv(ipop)
	   hetglobm=hetglobm+hetglob(ipop)
	   alleffmm=alleffmm+alleffm(ipop)
	   allobsmm=allobsmm+allobsm(ipop)
	   nalldiagnmt=	nalldiagnmt+nalldiagnm(ipop)
	   monom=monom+monoloc(ipop)
        enddo
	   nlocvm=nlocvm/npop
	   hetglobm=hetglobm/npop
	   alleffmm=alleffmm/npop
	   allobsmm=allobsmm/npop
	   monom=monom/npop
	   
c	   write(*,1115)(monopop(iloc),iloc=1,nloc)
c 1115    format(10(f5.0))	   
c	   write(*,1114)(npopv(iloc),iloc=1,nloc)
c	   write(*,*)(monopop(iloc)/npopv(iloc),iloc=1,nloc)
	   do iloc=1,nloc
	      if(npopv(iloc).eq.0)then
	         monopop(iloc)=-1
	      else
	         monopop(iloc)=monopop(iloc)/npopv(iloc)
	      endif
	   end do
	
c        write(*,*)'nalldiagn',((nalldiagn(ipop,iloc),iloc=1,nloc)
c     &        ,ipop=1,npop)
c        write(*,*)'nalldiagnm',(nalldiagnm(ipop),ipop=1,npop)

    
c ========== NOMS DES METH =======================            
      if(nmethode.eq.1)then
         fnomdist='NEIMB'

      elseif(nmethode.eq.2)then
         fnomdist='NEIMC'
      
      elseif(nmethode.eq.3)then
         fnomdist='NEISB'
      
      elseif(nmethode.eq.4)then
         fnomdist='NEISC'

      elseif(nmethode.eq.5)then
         fnomdist='REYNB'
       
      elseif(nmethode.eq.6)then
         fnomdist='REYNC'
	 
      elseif(nmethode.eq.7)then
         fnomdist='MORTB'
       
      elseif(nmethode.eq.8)then
         fnomdist='MORTC'
       
      elseif(nmethode.eq.9)then
         fnomdist='NEI87'
      endif

      
      fichneighbo=fnomdist//'.ngh'

      open(7,file=fichneighbo)
      fichsolu1=fnomdist//'.res'
      open(8,file=fichsolu1)
      
      open(17,file=fnomdist//'_wei.F')
      open(18,file=fnomdist//'_wei.1mF')
      open(19,file=fnomdist//'_wei.2sFm1')
      
c 12/12/02
	open(22,file=fnomdist//'.loc')
	write(22,*)'ipop  jpop  iloc  d'
c      
      
      if(nmethode.eq.1)then
      call neim(ngen,npop,nloc,nall,freqall0,d)

      elseif(nmethode.eq.2)then
      call neimcorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)
      
      elseif(nmethode.eq.3)then
      call neis(ngen,npop,nloc,nall,freqall0,d)
      
      elseif(nmethode.eq.4)then
      call neiscorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)

      elseif(nmethode.eq.5)then
      call reynolds(ngen,npop,nloc,nall,freqall0,d)
       
      elseif(nmethode.eq.6)then
      isortieloc=1
      call reycorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d,sd)
      isortieloc=0
      npop2=2
      do ipop=1,npop
         do iloc=1,nloc
            do iall=1,nall(iloc)
               freqall(2,1,iloc,iall)=freqall0(2,ipop,iloc,iall)  
               freqall(2,2,iloc,iall)=(freqmoy(iloc,iall)
     &                -freqall0(2,ipop,iloc,iall))/(npopv(iloc)-1) 
             enddo
	     nindiv2(1,iloc)=nindiv(ipop,iloc)
	     nindiv2(2,iloc)=1000
c	     write(*,*)(freqall(2,2,iloc,iall),iall=1,nall(iloc))
         enddo  
         call reycorri(ngen,npop2,nloc,nall,freqall,necht,
     &           nindiv2,d2,sd2)
c	 write(*,*)'d2',d2(2,2,1,2)
	 d1t(ipop)=d2(2,2,1,2) 
	 d1tm=d1tm+ d1t(ipop)
      enddo 
      d1tm=d1tm/npop

      elseif(nmethode.eq.7)then
      call morton(ngen,npop,nloc,nall,freqall0,d)
       
      elseif(nmethode.eq.8)then
      call mortoncorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)
       
      elseif(nmethode.eq.9)then
      call nei87(ngen,npop,nloc,nall,freqall0,d)
      
      endif
      
      
      
c le 26/8/8 pour mat sym
       do ipop=2,npop
       	   do jpop=1,(ipop-1)
	      d(2,2,ipop,jpop)=d(2,2,jpop,ipop)
	   enddo
       enddo     
	    

c  CONSTRUCTION : FICHIER POUR NEIGHBOR(7) et FICHIER RESULTATS(8)%
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      write(8,*)'Distance: ',fnomdist
      write(*,*)'Distance: ',fnomdist
      write(8,*)'Data file: ',fichdon1
      write(8,*)nloc,' loci and ',npop,
     &' populations'
      write(*,*)
      write(8,*)
      write(*,*)'Threshold sample size: ',seuil_tail
      write(8,*)'Threshold sample size: ',seuil_tail 

 103  format(a10,10(f7.4))
 1003 format(20(f4.0,1x))
 
      write(7,*)npop
      write(8,*)
      
      
c      write(*,*)'Heterozygoties moyennes, nb alleles efficaces'
      
c      do ipop=1,npop
c        write(*,*)nompop(ipop), nlocv(ipop),
c     &          hetglob(ipop), alleffm(ipop)
c      enddo
            
c      write(*,*)'Het par locus:'      
c      do ipop=1,npop
c        write(*,103)nompop(ipop), (het(ipop,iloc),iloc=1,nloc)	
c      enddo
c      write(*,*)'Nb all eff par locus:'   
c      do ipop=1,npop
c        write(*,103)nompop(ipop), (alleff(ipop,iloc),iloc=1,nloc)	
c      enddo
      write(8,*)
      write(8,*)'Loci in the analysis:'
      write(8,*)(igardeloc(iloc),iloc=1,nloc)
      write(8,*)
      write(8,*)'Pop    #syst   Het   ',
     & 'Eff.all.#   Obs.all.#    Dgn.all.#  d(1,t)   ',
     & '%mono'
      write(8,*)
      write(8,1112)'      ', nlocvm,
     &          hetglobm, alleffmm, allobsmm,
     &          nalldiagnmt,d1tm,monom
      write(8,*)
      
      do ipop=1,npop
        write(8,1111)nompop(ipop), nlocv(ipop),
     &          hetglob(ipop), alleffm(ipop), allobsm(ipop),
     &          nalldiagnm(ipop),d1t(ipop),monoloc(ipop)
      enddo
      
 1111 format(a8,x,i3,x,f8.4,x,f6.2,x,f6.2,2x,i3,2x,f7.4,2x,f5.3)
 1112 format(a6,x,f5.2,x,f8.4,x,f6.2,x,f6.2,2x,i3,2x,f7.4,2x,f5.3)
 
      write(8,*)
      write(8,*)'Percentage of monomorphic populations '
         write(8,1113)(monopop(iloc),iloc=1,nloc)
 1113   format(10(f5.3,x))
 
      write(8,*)
      write(8,*)'Nb of pop genotyped per locus'
         write(8,1114)(npopv(iloc),iloc=1,nloc)
 1114 format(10(i3,x))
 
      write(8,*)
      write(8,*)'Diagnostic allele number:'      
      do ipop=1,npop
        write(8,109)nompop(ipop), (nalldiagn(ipop,iloc),iloc=1,nloc)	
      enddo
 109  format(a8,x,20(i3))
      write(8,*)
 
      write(8,*)
      write(8,*)'Heterozygosity per locus (9=missing):'      
      do ipop=1,npop
        write(8,103)nompop(ipop), (het(ipop,iloc),iloc=1,nloc)	
      enddo
      write(8,*)
      write(8,*)'Effective allele number par locus (0=missing):'   
      do ipop=1,npop
        write(8,103)nompop(ipop), (alleff(ipop,iloc),iloc=1,nloc)	
      enddo
      write(8,*)
      write(8,*)'Observed allele number par locus (0=missing):'   
      do ipop=1,npop
        write(8,103)nompop(ipop), (allobs(ipop,iloc),iloc=1,nloc)	
      enddo      
      write(*,*)
      write(8,*)
      write(8,*)'Max nb of observed alleles (per locus)'
      write(8,105)(allobsloc(iloc),iloc=1,nloc)
  105 format(10(f6.0))
      write(8,*)

      write(8,*)'Distance matrix'
      do ipop=1,npop
c le 15/2/1
        nchgt=0
        do jpop=1,npop
	   if(d(2,2,ipop,jpop).lt.0.)then
	     d(2,2,ipop,jpop)=0.
	     nchgt=nchgt+1

	   endif
	enddo
	
c    
c        write(*,103)nompop(ipop), (d(2,2,ipop,jpop),jpop=1,npop)
        write(7,103)nompop(ipop), (d(2,2,ipop,jpop),jpop=1,npop)
        write(8,103)nompop(ipop), (d(2,2,ipop,jpop),jpop=1,npop)
	
	write(17,1003)(1000.*d(2,2,jpop,ipop),jpop=1,ipop)
	write(18,1003)(1000.*(1.-d(2,2,jpop,ipop)),jpop=1,ipop)
	write(19,1003)(10.*(2./d(2,2,jpop,ipop)-1.),jpop=1,ipop)
	
	if(nmethode.eq.6)then
c	   write(*,103)'   sd     ', (sd(2,2,ipop,jpop),jpop=1,npop)
	   write(8,103)'   sd     ', (sd(2,2,ipop,jpop),jpop=1,npop)
	endif
      enddo
      
	 write(*,*)'Nb de dist neg passees a 0 ', nchgt
	 write(8,*)'Nb of negative distances set to 0 ', nchgt      
c%%%%%%%%%%%%%%%%%%%%%%
c  DEBUT DU BOOTSTRAP %
c%%%%%%%%%%%%%%%%%%%%%%


      ELSEIF(nboot.gt.0)then

 	write(*,*)'Fichier des donnees bootstrapees'
      read(*,*)fichboot
c      open(10,file=fichboot,action="read")
      open(10,file=fichboot)
     

c ========== NOMS DES METH =======================            
      if(nmethode.eq.1)then
         fnomdist='NEIMB'

      elseif(nmethode.eq.2)then
         fnomdist='NEIMC'
      
      elseif(nmethode.eq.3)then
         fnomdist='NEISB'
      
      elseif(nmethode.eq.4)then
         fnomdist='NEISC'

      elseif(nmethode.eq.5)then
         fnomdist='REYNB'
       
      elseif(nmethode.eq.6)then
         fnomdist='REYNC'
	 
      elseif(nmethode.eq.7)then
         fnomdist='MORTB'
       
      elseif(nmethode.eq.8)then
         fnomdist='MORTC'
	 
      elseif(nmethode.eq.9)then
         fnomdist='NEI87' 

      endif


c debut boucle BOOT
c!!!!!!!!!!!!!!!!!!!!!    
 104  format(10(f7.4))  
      do iboot=1,nboot
      write(*,*)'Boot numero ',iboot,' sur ',nboot
      rewind(3)
      
      read(10,*)npopl,nloc
      do iloc=1,nloc
         igardeloc(iloc)=1
      enddo
      read(10,*)(nall(iloc),iloc=1,nloc)

      do igen=2,ngen
      
      ipop=0      
      read(3,*,iostat=ieof)ip,nompop(ip)
      
      do ipopl=1,npopl
      
         if(ip.eq.ipopl.and.ieof.eq.0)then 
	   ipop=ipop+1
      
           read(10,*)nompop(ipop)
           read(10,*)(nindiv(ipop,iloc),iloc=1,nloc)
           do iloc=1,nloc
             read(10,*)(freqall0(igen,ipop,iloc
     &               ,iall),iall=1,nall(iloc))
            enddo
       
       	   if(ipopl.ne.npopl) read(3,*,iostat=ieof)ip,nompop(ip)
	  
	 else
	   read(10,*)nompop(npopl)
           read(10,*)(nindiv(npopl,iloc),iloc=1,nloc)
           do iloc=1,nloc
             read(10,*)(freqall0(igen,npopl,iloc
     &               ,iall),iall=1,nall(iloc))
            enddo
	   	   
	 endif
	 

      enddo
      enddo
      
      npop=ipop

c modif le 10/7/1 : si taille echt < val seuil, alors on
c    elimine la cb pop x marq

       igen=2
       do ipop=1,npop
          do iloc=1,nloc
	     if(nindiv(ipop,iloc).lt.seuil_tail)then
	        do iall=1,nall(iloc)	        
    	           freqall0(igen,ipop,iloc,iall)=0.		   	     
	        enddo
	     endif
          enddo
       enddo       
       




c fin modif
      
      if(nmethode.eq.1)then
      call neim(ngen,npop,nloc,nall,freqall0,d)

      elseif(nmethode.eq.2)then
      call neimcorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)
      
      elseif(nmethode.eq.3)then
      call neis(ngen,npop,nloc,nall,freqall0,d)
      
      elseif(nmethode.eq.4)then
      call neiscorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)

      elseif(nmethode.eq.5)then
      call reynolds(ngen,npop,nloc,nall,freqall0,d)
       
      elseif(nmethode.eq.6)then
      call reycorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d,sd)

      elseif(nmethode.eq.7)then
      call morton(ngen,npop,nloc,nall,freqall0,d)
       
      elseif(nmethode.eq.8)then
      call mortoncorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)
      
      elseif(nmethode.eq.9)then
      call nei87(ngen,npop,nloc,nall,freqall0,d)

      endif
c      write(*,*)'YOYO'
      
      do ipop=1,npop
      do jpop=ipop+1,npop
      distboot(2,2,ipop,jpop)=distboot(2,2,ipop,jpop)
     &+d(2,2,ipop,jpop)
      d(2,2,jpop,ipop)=d(2,2,ipop,jpop)
      varboot(2,2,ipop,jpop)=varboot(2,2,ipop,jpop)
     &+(d(2,2,ipop,jpop))**2
      enddo
      enddo
      
c      write(*,*)'YOYOYO'

c   CONSTRUCTION DU FICHIER POUR NEIGHBOR(7)
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      fichneighbo=fnomdist//'_boot.ngh'
      open(7,file=fichneighbo)
      fichsolu1=fnomdist//'_boot.res'
      open(8,file=fichsolu1)
      
      write(7,*)npop
      do ipop=1,npop
       write(7,103)nompop(ipop), 
     &(d(2,2,ipop,jpop),jpop=1,npop)
      enddo
      
      
      
      
      enddo
c FIN DE BOUCLE BOOTSTRAPP 

      do ipop=1,npop
      do jpop=ipop+1,npop
      distboot(2,2,ipop,jpop)=distboot(2,2,ipop,jpop)
     &/dble(nboot)
      varboot(2,2,ipop,jpop)=varboot(2,2,ipop,jpop)
     &/dble(nboot)-(distboot(2,2,ipop,jpop))**2
      varboot(2,2,jpop,ipop)=dsqrt(varboot(2,2,ipop,jpop))
      enddo
      enddo


c CONSTRUCTION D UN FICHIER OPTIONNEL(8) DONNANT MOY ET VAR : 'N' BOOTSTRAP  %
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      write(8,*)'Distance :',fnomdist
      write(8,*)'Fichier source : ',fichdon1
      write(8,*)' '
      write(8,*)'pour ',nloc,' locus et',nboot,
     &' bootstrap'

c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c       ECRIRE LA MATRICE DES DISTANCES %
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


c      write(*,*)' '
c      write(*,*)'La matrice des distances moyennes '
      write(8,*)' '
      write(8,*)'La matrice des distances moyennes '
      
      do ipop=1,npop
c        write(*,103)nompop(ipop), 
c     &(distboot(2,2,ipop,jpop),jpop=1,npop)
          write(8,103)nompop(ipop),
     &(distboot(2,2,ipop,jpop),jpop=1,npop)
      enddo

      
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c       ECRIRE LA MATRICE DES VARIANCES + ecart types %
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c      write(*,*)'   '
c      write(*,*)'la matrice des variances et ecartypes :'
      write(8,*)'   '
      write(8,*)'la matrice des variances et ecartypes :'
      
      do ipop=1,npop
c        write(*,103)nompop(ipop), 
c     &(varboot(2,2,ipop,jpop),jpop=1,npop)
          write(8,103)nompop(ipop),
     &(varboot(2,2,ipop,jpop),jpop=1,npop)
      enddo



      ENDIF
c FIN DE IF BOOTSTRAPP OU NON



      stop
      end


c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c  PARTIE CALCUL DES DIFFERENTES DISTANCES
c %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



c     SOUS PROGRAMME : DISTANCE  de NEI MINIMUN
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine neim(ngen,npop,nloc,nall,freqall0,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer nall(nlocmax),nloc
      double precision ajx,ajy,ajxy
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision rmsloc(ngenmax,ngenmax,npopmax,npopmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
            
      common /bloc1/ igardeloc
      
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
           do jpop=ipop+1,npop
	   
             rmsloc(igen,jgen,ipop,jpop)=0.
             d(igen,jgen,ipop,jpop)=0.
     	     ajx=0.
     	     ajy=0.
     	     ajxy=0.
	     nlocv=0
             do iloc=1,nloc
	     if(igardeloc(iloc).ne.0)then
	       som1=0.
	       som2=0.
	       do iall=1,nall(iloc)
               som1=som1+freqall0(igen,ipop,iloc,iall)
               som1=som1+freqall0(jgen,jpop,iloc,iall)
              enddo
	      if(som1*som2.ne.0.)then
	        nlocv=nlocv+1
                  do iall=1,nall(iloc)
                    ajx=ajx+(freqall0(igen,ipop,iloc,iall))**2
                    ajy=ajy+(freqall0(jgen,jpop,iloc,iall))**2
                    ajxy=ajxy+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
                  enddo
	       endif
	     endif 
             enddo
             ajx=ajx/dble(nlocv)
             ajy=ajy/dble(nlocv)
             ajxy=ajxy/dble(nlocv)
             rmsloc(igen,jgen,ipop,jpop)=(ajx+ajy)/2-ajxy
             d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &+rmsloc(igen,jgen,ipop,jpop)
             
          enddo
         enddo
        enddo
       enddo

      return 
      end






c     SOUS PROGRAMME : DISTANCE  de NEI MINIMUM CORRIGEE
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine neimcorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer necht(npopmax),nindiv(npopmax,nlocmax)
      integer nall(nlocmax),nloc
      double precision ajx,ajy,ajxy,ajxtild,ajytild
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision rmsloc(ngenmax,ngenmax,npopmax,npopmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
      
      common /bloc1/ igardeloc
      
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
           do jpop=ipop+1,npop
             rmsloc(igen,jgen,ipop,jpop)=0.
             d(igen,jgen,ipop,jpop)=0.
     	     ajxy=0.
     	     ajxtild=0.
     	     ajytild=0.
	     nlocv=0
             do iloc=1,nloc
	     if(igardeloc(iloc).ne.0)then
              ajx=0.
     	      ajy=0.
	      ajxyl=0.
	      som1=0.
	      som2=0.
	      do iall=1,nall(iloc)
                ajxyl=ajxyl+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
                som1=som1+freqall0(igen,ipop,iloc,iall)
		som2=som2+freqall0(jgen,jpop,iloc,iall)
              enddo
	      if(som1*som2.ne.0.) then
	        nlocv=nlocv+1
                do iall=1,nall(iloc)
     	          ajx=ajx+(freqall0(igen,ipop,iloc,iall))**2
                  ajy=ajy+(freqall0(jgen,jpop,iloc,iall))**2
                   ajxy=ajxy+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
                enddo
                ajxtild=ajxtild+(ajx-(1./dble(nindiv(ipop,iloc))))/
     &(1.-(1./dble(nindiv(ipop,iloc))))
                ajytild=ajytild+(ajy-(1./dble(nindiv(jpop,iloc))))/
     &(1.-(1./dble(nindiv(jpop,iloc))))
               endif
	      endif
              enddo
             ajxtild=ajxtild/dble(nlocv)
             ajytild=ajytild/dble(nlocv)
             ajxy=ajxy/dble(nlocv)
             rmsloc(igen,jgen,ipop,jpop)=(ajxtild+ajytild)/2
     &-ajxy
             d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &+rmsloc(igen,jgen,ipop,jpop)
          enddo
         enddo
        enddo
       enddo



      return 
      end

c     SOUS PROGRAMME : DISTANCE  de NEI STANDARD
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine neis(ngen,npop,nloc,nall,freqall0,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer nall(nlocmax),nloc
      double precision ajx,ajy,ajxy,aI
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)      
      
      common /bloc1/ igardeloc      
 
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
           do jpop=ipop+1,npop
             d(igen,jgen,ipop,jpop)=0.
              ajx=0.
     	      ajy=0.
     	      ajxy=0.
     	      do iloc=1,nloc
	      if(igardeloc(iloc).ne.0)then
	        ajxyl=0.
		som1=0.
		som2=0.
                do iall=1,nall(iloc)                  
                  ajxyl=ajxyl+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
                   som1=som1+freqall0(igen,ipop,iloc,iall)
		   som2=som2+freqall0(jgen,jpop,iloc,iall)
                enddo
		if(som1*som2.ne.0.) then
		  do iall=1,nall(iloc)
                    ajx=ajx+(freqall0(igen,ipop,iloc,iall))**2
                    ajy=ajy+(freqall0(jgen,jpop,iloc,iall))**2
                    ajxy=ajxy+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
                  enddo
		endif
	     endif
             enddo
             aI=-log(ajxy/dble(sqrt(ajx*ajy)))
             d(igen,jgen,ipop,jpop)=-log(ajxy/dble(sqrt(ajx*ajy)))
          enddo
         enddo
        enddo
       enddo

      return 
      end






c     SOUS PROGRAMME : DISTANCE  de NEI  STANDARD CORRIGEE
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine neiscorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer necht(npopmax),nindiv(npopmax,nlocmax)
      integer nall(nlocmax),nloc
      double precision ajx,ajy,ajxy,ajxtild,ajytild
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
      
      common /bloc1/ igardeloc      
      
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
           do jpop=ipop+1,npop
             d(igen,jgen,ipop,jpop)=0.
     	     ajxy=0.
     	     ajxtild=0.
     	     ajytild=0.
             do iloc=1,nloc
	     if(igardeloc(iloc).ne.0)then
               som1=0.
     	       som2=0.
	       ajxyl=0.
	       ajx=0.
	       ajy=0.
               do iall=1,nall(iloc)
     	         som1=som1+(freqall0(igen,ipop,iloc,iall))
                 som2=som2+(freqall0(jgen,jpop,iloc,iall))
		 ajx=ajx+freqall0(igen,ipop,iloc,iall)**2
		 ajy=ajy+freqall0(jgen,jpop,iloc,iall)**2
		 ajxyl=ajxyl+freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall)
                 ajxy=ajxy+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
               enddo
	       if(som1*som2.ne.0.)then
                ajxtild=ajxtild+(ajx-(1./dble(nindiv(ipop,iloc))))/
     &(1.-(1./dble(nindiv(ipop,iloc))))
                ajytild=ajytild+(ajy-(1./dble(nindiv(jpop,iloc))))/
     &(1.-(1./dble(nindiv(jpop,iloc))))
               endif
	     endif
             enddo
             d(igen,jgen,ipop,jpop)=-log(ajxy/dble(sqrt
     &(ajxtild*ajytild)))
          enddo
         enddo
        enddo
       enddo



      return 
      end


c     SOUS PROGRAMME : DISTANCE  de REYNOLDS
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine reynolds(ngen,npop,nloc,nall,freqall0,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer nall(nlocmax),nloc
      double precision rinvxyloc
      double precision ss,rinvxyl
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision rmsloc
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
            
      common /bloc1/ igardeloc      
      
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
            do jpop=ipop+1,npop
               rmsloc=0.
	       nlocv=0
               d(igen,jgen,ipop,jpop)=0.
               rinvxyl=0.
               ss=0.	       
	       
	       do iloc=1,nloc
	       if(igardeloc(iloc).ne.0) then
	         som1=0.
		 som2=0.
                  do iall=1,nall(iloc)
                     som1=som1+freqall0(igen,ipop,iloc,iall)
                      som2=som2+freqall0(jgen,jpop,iloc,iall)        
                  enddo
              	       
	          if(som1*som2.ne.0.)then
	            nlocv=nlocv+1                 
                    do iall=1,nall(iloc)
                      ss=ss+(freqall0(igen,ipop,iloc,iall)
     &-freqall0(jgen,jpop,iloc,iall))**2           
                    enddo
		  endif 
	       endif
               enddo
	       	       
               ss=ss/dble(2*nlocv)
               rmsloc=rmsloc+ss
               rinvxyl=rinvxyloc(igen,jgen,ipop,jpop,
     &nloc,nall,freqall0)
               if(rinvxyl.eq.0)then
	          rmsloc=0
	       else
	       rmsloc=rmsloc/rinvxyl
               d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &+rmsloc
	       endif
                    
            enddo
         enddo
        enddo
       enddo                  
      

      return
      end



c     SOUS PROGRAMME : DISTANCE  de REYNOLDS CORRIGEE
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine reycorri(ngen,npop,nloc,nall,freqall0,necht,nindiv,
     &             d,sd)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer necht(npopmax),nindiv(npopmax,nlocmax)
      integer nall(nlocmax),nloc,nlocv
      double precision rinvxyloc,ajx,ajy,ajxy,ajxtild,ajytild,ajxyl
      double precision rinvxyl
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision rmsloc,var,d2l,numl,denoml

      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      double precision sd(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
            
      common /bloc1/ igardeloc
      common /bloc2/ isortieloc
            
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
           do jpop=ipop+1,npop
             rmsloc=0.
             d(igen,jgen,ipop,jpop)=0.
             rinvxyl=0.
             rinvxyl=rinvxyloc(igen,jgen,ipop,jpop,
     &nloc,nall,freqall0)
     	     ajxy=0.	     
     	     ajxtild=0.
     	     ajytild=0.
	     nlocv=0
	     var=0.
	     nlocrey=0
             do iloc=1,nloc
	     if(igardeloc(iloc).ne.0)then
              som1=0.
     	      som2=0.
	      ajx=0.
	      ajy=0.
	      ajxyl=0.
	      numl=0.	
	      denoml=0. 
	      nallcom=0.    
              do iall=1,nall(iloc)
	        fi=freqall0(igen,ipop,iloc,iall)
		fj=freqall0(jgen,jpop,iloc,iall)
		som1=som1+fi
                som2=som2+fj
		ajx=ajx+fi*fi
		ajy=ajy+fj*fj
                ajxyl=ajxyl+fi*fj
		if(fi+fj.gt.0.)nallcom=nallcom+1
              enddo
	      ajxy=ajxy+ajxyl
	      if(som1*som2.ne.0.) then
	       nlocv=nlocv+1 
	       a= (ajx-(1./dble(nindiv(ipop,iloc))))/
     &(1.-(1./dble(nindiv(ipop,iloc))))
              ajxtild=ajxtild+ a
	      numl=numl+a
	       a = (ajy-(1./dble(nindiv(jpop,iloc))))/
     &(1.-(1./dble(nindiv(jpop,iloc))))
              ajytild=ajytild+ a
	       numl=numl+a
	       numl=numl/2. - ajxyl
	       denoml=1.-ajxyl
	       if(denoml.ne.0.and.nallcom.ne.1) then
	          d2l=numl/denoml
c	       d2=d2+d2l
c  d2 est somme_l D_Rey,l alors que d est som_l num / som_l denom
	       var=var
     &             +2.*(d2l+0.5/nindiv(ipop,iloc)
     &                           +0.5/nindiv(jpop,iloc))
     &               / dble(nallcom-1)
     		else
		  d2l=0
                endif
		if (isortieloc.eq.1) then
		   write(22,1000) ipop,jpop,iloc,d2l
 1000	format(3i6,f8.4)		   
		endif
               endif 
	     endif 	       
             enddo
c	     write(*,*)'nlocv',nlocv,ipop,jpop
	     if(nlocv.eq.0)write(*,*)'nlocv=0 entre ',ipop,jpop
             ajxtild=ajxtild/dble(nlocv)
             ajytild=ajytild/dble(nlocv)
             ajxy=ajxy/dble(nlocv)
             rmsloc=(ajxtild+ajytild)/2-ajxy
	     if(rinvxyl.eq.0)then
	        d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)+0
	     else
	        d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &                +rmsloc/rinvxyl
	     endif
             
c /nlocv le 14/9/00, recorrige le 8/2/1
             sd(igen,jgen,ipop,jpop)=dsqrt(var)/nlocv
 
             if(d(igen,jgen,ipop,jpop).lt.0.)
     &                  d(igen,jgen,ipop,jpop)=0.
     
          enddo
         enddo
        enddo
       enddo

      return 
      end


c     SOUS PROGRAMME : DISTANCE  de NEI 1987 (utilisee par Jan Meyer)
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine nei87(ngen,npop,nloc,nall,freqall0,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer nall(nlocmax),nloc
      double precision ajx,ajy,ajxy
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
            
      common /bloc1/ igardeloc
      
       do igen=2,ngen
        do jgen=2,ngen
	
         do ipop=1,npop
           do jpop=ipop+1,npop
             nlocc=nloc
             d(igen,jgen,ipop,jpop)=0.
             do iloc=1,nloc
	     if(igardeloc(iloc).ne.0)then	     
 	     ajx=0.
     	     ajy=0.
     	     ajxy=0.
	     som1=0.
	     som2=0.
              do iall=1,nall(iloc)
               ajx=ajx+(freqall0(igen,ipop,iloc,iall))**2
               ajy=ajy+(freqall0(jgen,jpop,iloc,iall))**2
               ajxy=ajxy+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
               som1=som1+freqall0(igen,ipop,iloc,iall)
	       som2=som2+freqall0(jgen,jpop,iloc,iall)
              enddo
	      if(som1*som2.eq.0.)then
	          nlocc=nlocc-1
	      else
	          d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &+dsqrt(ajx+ajy-2.*ajxy)
              endif
	     endif
             enddo
	      d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &/dble(nlocc)
          enddo
         enddo
	 
        enddo
       enddo

      return 
      end


c     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c     FUNCTION:CALCUL DE 1-la somme de xi*yi %
c     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     
      function rinvxyloc(igen,jgen,ipop,jpop,nloc,nall,freqall0)
      parameter(ngenmax=5,npopmax=80,nlocmax=150
     &,nallmax=50)
      integer nall(nlocmax),nloc,nlocv 
      double precision xy,xyloc,rinvxyloc,xyl
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      integer igardeloc(nlocmax)
      
      common /bloc1/ igardeloc
      
      xy=0.
      xyloc=0.
      nlocv=0
            do iloc=1,nloc
	    if(igardeloc(iloc).ne.0)then
	       xyl=0.
	       som1=0.
	       som2=0.
               do iall=1,nall(iloc)
                  xyl=xyl
     &+(freqall0(igen,ipop,iloc,iall)*freqall0(jgen,jpop,
     &iloc,iall))
                  som1=som1+freqall0(igen,ipop,iloc,iall)
		  som2=som2+freqall0(jgen,jpop,iloc,iall)
                enddo
		xy=xy+xyl
		if(som1*som2.ne.0.) nlocv=nlocv+1
	    endif
            enddo
c	    write(*,*)'nlocv',nlocv
	    if(nlocv.eq.0)write(*,*)'nlocv=0 entre ',ipop,jpop
            xyloc=xyloc+xy
            xyloc=xyloc/dble(nlocv)
            rinvxyloc=1-xyloc      
 
      return 
      end
      
      
c     SOUS PROGRAMME : DISTANCE  de MORTON
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine morton(ngen,npop,nloc,nall,freqall0,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer nall(nlocmax),nloc
      double precision rinvxylox
      double precision ss,rinvxyl
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision rmsloc(ngenmax,ngenmax,npopmax,npopmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
            
      common /bloc1/ igardeloc      
      
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
            do jpop=ipop+1,npop
               rmsloc(igen,jgen,ipop,jpop)=0.
               d(igen,jgen,ipop,jpop)=0.
               rinvxyl=0.
               ss=0.
	       nlocv=0
               do iloc=1,nloc
	       if(igardeloc(iloc).ne.0)then
	          som1=0.
		  som2=0.
		  do iall=1,nall(iloc)
                     som1=som1+freqall0(igen,ipop,iloc,iall)
                     som2=som2+freqall0(jgen,jpop,iloc,iall)        
                  enddo
		  if(som1*som2.ne.0.)then
		    nlocv=nlocv+1
                    do iall=1,nall(iloc)
                       ss=ss+(freqall0(igen,ipop,iloc,iall)
     &-freqall0(jgen,jpop,iloc,iall))**2           
                    enddo
		  endif
	       endif
               enddo
               ss=ss/dble(2*nlocv)
               rmsloc(igen,jgen,ipop,jpop)=
     &rmsloc(igen,jgen,ipop,jpop)+ss
               rinvxyl=rinvxylox(igen,jgen,ipop,jpop,
     &nloc,nall,freqall0)     
               rmsloc(igen,jgen,ipop,jpop)=
     &rmsloc(igen,jgen,ipop,jpop)/rinvxyl
               d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &+rmsloc(igen,jgen,ipop,jpop)
            enddo
         enddo
        enddo
       enddo                  
      

      return
      end



c     SOUS PROGRAMME : DISTANCE  de MORTON CORRIGEE
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine mortoncorri(ngen,npop,nloc,nall,freqall0,necht
     &,nindiv,d)
      parameter(ngenmax=5,npopmax=80,
     &nlocmax=150,nallmax=50)
      integer necht(npopmax),nindiv(npopmax,nlocmax)
      integer nall(nlocmax),nloc
      double precision rinvxylox,ajx,ajy,ajxy,ajxtild,ajytild
      double precision rinvxyl
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      double precision rmsloc(ngenmax,ngenmax,npopmax,npopmax)
      double precision d(ngenmax,ngenmax,npopmax,npopmax)
      integer igardeloc(nlocmax)
            
      common /bloc1/ igardeloc      
 
       do igen=2,ngen
        do jgen=2,ngen
         do ipop=1,npop
           do jpop=ipop+1,npop
             rmsloc(igen,jgen,ipop,jpop)=0.
             d(igen,jgen,ipop,jpop)=0.
             rinvxyl=0.
             rinvxyl=rinvxylox(igen,jgen,ipop,jpop,
     &nloc,nall,freqall0)

     	     ajxy=0.
     	     ajxtild=0.
     	     ajytild=0.
	     nlocv=0
             do iloc=1,nloc
	     if(igardeloc(iloc).ne.0)then
              ajx=0.
     	      ajy=0.	      
	      som1=0.
	      som2=0.
	      do iall=1,nall(iloc)
               som1=som1+freqall0(igen,ipop,iloc,iall)
               som2=som2+freqall0(jgen,jpop,iloc,iall)
              enddo
	      if(som.ne.0.) then
	        nlocv=nlocv+1
                do iall=1,nall(iloc)
     	          ajx=ajx+(freqall0(igen,ipop,iloc,iall))**2
                  ajy=ajy+(freqall0(jgen,jpop,iloc,iall))**2
                  ajxy=ajxy+(freqall0(igen,ipop,iloc,iall)
     &*freqall0(jgen,jpop,iloc,iall))
                enddo
                ajxtild=ajxtild+(ajx-(1./dble(nindiv(ipop,iloc))))/
     &(1.-(1./dble(nindiv(ipop,iloc))))
                ajytild=ajytild+(ajy-(1./dble(nindiv(jpop,iloc))))/
     &(1.-(1./dble(nindiv(jpop,iloc))))
               endif
	     endif
             enddo
             ajxtild=ajxtild/dble(nlocv)
             ajytild=ajytild/dble(nlocv)
             ajxy=ajxy/dble(nlocv)
             rmsloc(igen,jgen,ipop,jpop)=(ajxtild+ajytild)/2
     &-ajxy
             rmsloc(igen,jgen,ipop,jpop)=rmsloc(igen
     &,jgen,ipop,jpop)/rinvxyl
             d(igen,jgen,ipop,jpop)=d(igen,jgen,ipop,jpop)
     &+rmsloc(igen,jgen,ipop,jpop)

          enddo
         enddo
        enddo
       enddo


      return 
      end


c     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c     FUNCTION:CALCUL DE 1-la somme de ((xi+yi)/2) %
c     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     
      function rinvxylox(igen,jgen,ipop,jpop,nloc,nall,freqall0)
      parameter(ngenmax=5,npopmax=80,nlocmax=150
     &,nallmax=50)
      integer nall(nlocmax),nloc 
      double precision xy,xyloc,rinvxylox
      double precision freqall0(ngenmax,npopmax,
     &nlocmax,nallmax)
      integer igardeloc(nlocmax)
      
      common /bloc1/ igardeloc
      
      xy=0.
      xyloc=0.
      nlocv=0      
	    
 
          do iloc=1,nloc
	  if(igardeloc(iloc).ne.0)then
	     som1=0.
	     som2=0.
	     do iall=1,nall(iloc)
                 som1=som1+freqall0(igen,ipop,iloc,iall)
                  som2=som2+freqall0(jgen,jpop,iloc,iall)
              enddo
	      if(som1*som2.ne.0.)then
	        nlocv=nlocv+1
                do iall=1,nall(iloc)
                  xy=xy+((freqall0(igen,ipop,iloc,iall)
     &+freqall0(jgen,jpop,iloc,iall))/2)**2 
                enddo
	      endif
	  endif
          enddo
c	  write(*,*)'nlocv',nlocv
	  if(nlocv.eq.0) write(*,*)'nlocv=0 entre ',ipop,jpop
          xyloc=xyloc+xy
          xyloc=xyloc/dble(nlocv)
          rinvxylox=1-xyloc 
         
        
      return 
      end
      

         

